!  .
!  1,   | http://kremer.pro/blog/?post_type=post&p=60
! $ gfortran -c main.f90 floyd.f90 matr_service.f90
! $ gfortran -o main.o floyd.o matr_service.o
! $ ./a.out

subroutine floyd(matrix, n, matSize, num_threads)
    implicit none
    real get_minimum
    include "omp_lib.h"

    integer n, matSize
    real matrix(n)
    integer num_threads

    integer k, i, j
    real t1, t2

    call omp_set_num_threads(num_threads)

    do k = 1, matSize
!$omp parallel do schedule(runtime) private(t1, t2)
        do i = 1, matSize
            do j = 1, matSize
                if ((matrix((i - 1) * matSize + (k-1) + 1) /= -1.0) .AND. &
                    (matrix((k - 1) * matSize + (j-1) + 1) /= -1.0)) then
                    t1 = matrix((i-1) * matSize + (j-1) + 1)
                    t2 = matrix((i-1) * matSize + (k-1) + 1) + &
                            matrix((k-1) * matSize + (j-1) + 1)
                    matrix((i-1) * matSize + (j-1) + 1) = get_minimum(t1, t2)
                endif
            enddo
        enddo
    enddo
end subroutine floyd

real function get_minimum(a, b) result(res)
    real a, b

    res = min(a, b)

    if ((a < 0) .AND. (b >= 0)) res = b
    if ((b < 0) .AND. (a >= 0)) res = a;
    if ((a < 0) .AND. (b < 0))  res = -1.0;

    return ! res
end function get_minimum
