! Алгоритм Флойда.
! Лабораторная №1, Кремер Илья | http://kremer.pro/blog/?post_type=post&p=60
! $ gfortran -c main.f90 floyd.f90 matr_service.f90
! $ gfortran -o main.o floyd.o matr_service.o
! $ ./a.out

program main
    implicit none
    include "omp_lib.h"
    real, allocatable, dimension(:) :: matrix
    integer nvertices, totalMatSize
    integer num_threads
    double precision start
    character(5) argv

    call set_nthreads(num_threads)
    call set_nvertices(nvertices)

    totalMatSize = nvertices * nvertices
    allocate(matrix(totalMatSize))

    call init_matr(matrix, totalMatSize, nvertices) ! INIT

    call getarg(1, argv)
    if (argv /= "-q") then
        print '(/a/)', "Исходная матрица смежности:"
        call print_matr(matrix, totalMatSize, nvertices) ! PRINT ORIGINAL
    endif

    start = omp_get_wtime()
    call floyd(matrix, totalMatSize, nvertices, num_threads) ! SOLVE
    print '(a, 4x, f8.6)', "Решение заняло секунд:", omp_get_wtime() - start

    if (argv /= "-q") then
        print '(a/)', "Решение:"
        call print_matr(matrix, totalMatSize, nvertices) ! PRINT SOLUTION
    endif
end program main

subroutine set_nthreads(num_threads)
    do while (.TRUE.)
    write (*, '(a)', advance='no'), "Нитей: "
    read *, num_threads
    if (num_threads > 64) then
        print *, "Ограничение -- 64 нити"
    else
        exit
    endif
enddo
end subroutine set_nthreads

subroutine set_nvertices(nvertices)
    do while (.TRUE.)
        write (*, '(a)', advance='no'), "Количество вершин: "
        read *, nvertices
        if (nvertices < 3) then
            print *, "Должно быть больше двух!"
        else
            exit
        endif
    enddo
end subroutine set_nvertices
