! Алгоритм Флойда.
! Лабораторная №1, Кремер Илья | http://kremer.pro/blog/?post_type=post&p=60
! $ gfortran -c main.f90 floyd.f90 matr_service.f90
! $ gfortran -o main.o floyd.o matr_service.o
! $ ./a.out

subroutine print_matr(matrix, n, matSize)
    integer n, matSize
    real matrix(n)

    integer i

    do i = 1, n
        write (*, '(f8.2)', advance='no'), matrix(i)
        if (mod(i, matSize) == 0) print '(/)'
    enddo
end subroutine print_matr

subroutine init_matr(matrix, n, matSize)
    integer n, matSize
    real matrix(n)

    integer i

    call init_random_seed()
    do i = 1, n
        call random_number(random)
        random = int(random * 10) - 1
        if (mod((i-1), matSize + 1) == 0) then
            matrix(i) = 0
        else if (random < 1) then
            matrix(i) = -1
        else
            matrix(i) = random
        endif
    enddo
end subroutine init_matr

SUBROUTINE init_random_seed()
! Взято с http://gcc.gnu.org/onlinedocs/gfortran/RANDOM_005fSEED.html
! (выложено как пример)
    INTEGER :: i, n, clock
    INTEGER, DIMENSION(:), ALLOCATABLE :: seed

    CALL RANDOM_SEED(size = n)
    ALLOCATE(seed(n))

    CALL SYSTEM_CLOCK(COUNT=clock)

    seed = clock + 37 * (/ (i - 1, i = 1, n) /)
    CALL RANDOM_SEED(PUT = seed)

    DEALLOCATE(seed)
END SUBROUTINE
